// FILE: ./assets/js/services/Ped00100_lancamentoPedido_Service.js
var  Ped00100_lancamentoPedido_Service = function(Ped00100_lancamentoPedido_Repository, localStorageEngine){

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - DESKTOP
    this.getNewCode = function(params) {
        var filial = { "filial": params};
        return Ped00100_lancamentoPedido_Repository.getNewCode(filial);
    };

    this.updateOrder = function(row) {
        return Ped00100_lancamentoPedido_Repository.updateOrder(row);
    };
    this.calcImpostoItem = function(dataset){
      return Ped00100_lancamentoPedido_Repository.calcImpostoItem(dataset);  
    };
    
     this.deletePrazo = function(data) {
        return Ped00100_lancamentoPedido_Repository.deletePrazo(data);
    };

    this.findModpgtoPrazo = function(filter) {
        return Ped00100_lancamentoPedido_Repository.findModpgtoPrazo(filter);
    };

    this.retornaParamPedido = function() {
        return Ped00100_lancamentoPedido_Repository.retornaParamPedido();
    };

    this.retornaPrecobase = function() {
        return Ped00100_lancamentoPedido_Repository.retornaPrecobase();
    };

    this.retornaPrecobasecli = function() {
        return Ped00100_lancamentoPedido_Repository.retornaPrecobasecli();
    };

    this.retornaPendenciaFin = function() {
        return Ped00100_lancamentoPedido_Repository.retornaPendenciaFin();
    };

    this.checkLogin = function(filter) {
        return Ped00100_lancamentoPedido_Repository.checkLogin(filter);
    };

    this.savePedido = function(data) {
        return Ped00100_lancamentoPedido_Repository.savePedido(data);
    };

    var getDataSourceConfigTransmissao = function() {
        return localStorageEngine.getDataSource("df#/config_transmissao").then(function(transmissao){
            return transmissao[0].config;
        });
    };
    
    this.statusServico = function(notasfiscais){
        return getDataSourceConfigTransmissao().then(function(config){
            return Ped00100_lancamentoPedido_Repository.statusServico(notasfiscais, config);
        });
    };

    this.montaConfigTransmissao = function(pedido){
        
         var row = {
            'CDEMPRESA': pedido.CDEMPRESA,
            'CDINSCESTA': pedido.CDINSCESTA,
            'CDFILIAL': pedido.CDFILIAL,
            'NRORG': pedido.NRORG
        };
        
        return Ped00100_lancamentoPedido_Repository.montaConfigTransmissao(row);
    };


    
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - DESKTOP & MOBILE

    this.saveData = function(name, dataSource) {
        return localStorageEngine.save(name, dataSource);
    };
    this.setData = function(name, dataSource) {
        return localStorageEngine.setDataSource(name, dataSource);
    };
    this.getData = function(name) {
        return localStorageEngine.getDataSource(name);
    };
    this.getLocalVar = function(name) {
        return localStorageEngine.getLocalVar(name);
    };


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - MOBILE
    this.enviarPedido = function(data) {
        return Ped00100_lancamentoPedido_Repository.enviarPedido(data);
    };
    this.filtraVendedor = function(filter) {
        return Ped00100_lancamentoPedido_Repository.filtraVendedor(filter);
    };
    this.retornaDadosUnidade = function(filter) {
        return Ped00100_lancamentoPedido_Repository.retornaDadosUnidade(filter);
    };
    this.filtraFilioper = function(filter) {
        return Ped00100_lancamentoPedido_Repository.filtraFilioper(filter);
    };
    this.findClienteVendedor = function(filter) {
        return Ped00100_lancamentoPedido_Repository.findClienteVendedor(filter);
    };
    this.findQTprod = function() {
        return Ped00100_lancamentoPedido_Repository.findQTprod();
    };
    this.findModpgto = function() {
        return Ped00100_lancamentoPedido_Repository.findModpgto();
    };
    this.findModpgtoPrazoMod = function() {
        return Ped00100_lancamentoPedido_Repository.findModpgtoPrazoMod();
    };
    this.findParameters = function(filter) {
        return Ped00100_lancamentoPedido_Repository.findParameters(filter);
    };
    
    this.findParamPedido = function(filter) {
      return Ped00100_lancamentoPedido_Repository.findParamPedido(filter);  
    };
    
    this.findTpdesc = function() {
        return Ped00100_lancamentoPedido_Repository.findTpdesc();
    };
    this.findTpOperac = function(filter) {
        return Ped00100_lancamentoPedido_Repository.findTpOperac(filter);
    };
    this.findProduto = function(filter) {
        return Ped00100_lancamentoPedido_Repository.findProduto(filter);
    };

    this.saveItem = function(data) {
        return Ped00100_lancamentoPedido_Repository.saveItem(data);
    };

    this.savePrazo = function(data) {
        return Ped00100_lancamentoPedido_Repository.savePrazo(data);
    };

    this.enviarEmail = function(/*emails, */data) {
        return Ped00100_lancamentoPedido_Repository.enviarEmail(/*emails, */data);
    };
    
    this.deletePedido = function(row) {
        return Ped00100_lancamentoPedido_Repository.deletePedido(row);
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('Ped00100_lancamentoPedido_Service', Ped00100_lancamentoPedido_Service);
});
