var  Ped05300_recalculo_preco_pedido_Controller = function(ScreenService, Ped05300_recalculo_preco_pedido_Service,General, templateManager, ZHPromise, localStorageEngine,
                                                        restEngine, MessageService){
                                                            
    this.enableTabPreco = function(){// Habilita  campo preço origem e preço destino de acordo  com o tipo de alteração
       var widgetFormRecalc = templateManager.container.getWidget('widgetRecalPrecoPed');
       var widgetRecalc = templateManager.container.getWidget('widgetPedRecalc');
       var tipoRecalc = widgetFormRecalc.currentRow.IDOPCAO;
       
       if(tipoRecalc == '1'){
           
           widgetFormRecalc.getField('DSPRECOBASEINI').validations = {required:true};
           widgetFormRecalc.getField('DSPRECOBASEFIN').reload();
           widgetFormRecalc.getField('DSPRECOBASEINI').reload();
           widgetFormRecalc.getField('DSPRECOBASEFIN').readOnly = false;
           widgetFormRecalc.getField('DSPRECOBASEINI').readOnly = false;
           widgetFormRecalc.getField('DSPRECOBASEFIN').validations = {required:true};
           widgetRecalc.actions[0].isVisible = false;
           widgetRecalc.actions[1].isVisible = true;

           
       }else{
           widgetFormRecalc.getField('DSPRECOBASEFIN').clearValue();
           widgetFormRecalc.getField('DSPRECOBASEINI').clearValue();
           widgetFormRecalc.getField('DSPRECOBASEFIN').readOnly = true;
           widgetFormRecalc.getField('DSPRECOBASEINI').readOnly = true;
           widgetFormRecalc.getField('DSPRECOBASEFIN').validations = {};
           widgetFormRecalc.getField('DSPRECOBASEINI').validations = {};
           widgetFormRecalc.getField('DSPRECOBASEFIN').reload();
           widgetFormRecalc.getField('DSPRECOBASEINI').reload();
           widgetRecalc.actions[0].isVisible = true;
           widgetRecalc.actions[1].isVisible = false;
       }
    };  
    
    this.setFilial = function(widget){//seta valor default dos campos Filial, data atual, e tipo alteração
        widget.getField('BODTATUAL').setValue('N');
        widget.getField('IDOPCAO').setValue('0');
        General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(callback) {
        widget.currentRow.NMFILIAL = callback.dataset.filial[0].NMFILIAL;
        widget.currentRow.CDFILIAL = callback.dataset.filial[0].CDFILIAL;
            
        });
    };
    this.checkValidteWidget = function(){// verifica se a widget formulário está válida
        var widgetFormRecalc = templateManager.container.getWidget('widgetRecalPrecoPed');
        
        if(widgetFormRecalc.isValid()){
            this.buscaPedRecalc();
        }else{
            ScreenService.showMessage('Preencha os campos Pedido Inicial e Pedido Final.');
        }
        
    };
    
    
    this.buscaPedRecalc =function(){// busca  os pedidos passíveis de alteração e exibe no grid
        var widgetFormRecalc = templateManager.container.getWidget('widgetRecalPrecoPed');
        var widgetRecalc = templateManager.container.getWidget('widgetPedRecalc');
        var widgetItensAtual = templateManager.container.getWidget('widgetItemPrecoAtual');
        var widgetItensNovo = templateManager.container.getWidget('widgetItemPrecoAlterado');
        var tipoAlterac = widgetFormRecalc.currentRow.IDOPCAO;
        var idAtual = widgetFormRecalc.currentRow.BODTATUAL;
        
        
        
        var row = [];
        
        if(tipoAlterac == "0"){
            row = {
                CDFILIAL : widgetFormRecalc.currentRow.CDFILIAL,
                NRPEDIDOINI:widgetFormRecalc.currentRow.NRPEDIDOINI,
                NRPEDIDOFIM: widgetFormRecalc.currentRow.NRPEDIDOFIM,
                BODTATUAL:idAtual,
                IDOPCAO: tipoAlterac
                
            };
            
        }else if(tipoAlterac == "1"){
            row = {
                CDFILIAL : widgetFormRecalc.currentRow.CDFILIAL,
                NRPEDIDOINI:widgetFormRecalc.currentRow.NRPEDIDOINI,
                NRPEDIDOFIM: widgetFormRecalc.currentRow.NRPEDIDOFIM,
                CDPRECOBASEINI:widgetFormRecalc.currentRow.CDPRECOBASEINI,
                CDPRECOBASEFIN: widgetFormRecalc.currentRow.CDPRECOBASEFIN,
                BODTATUAL:idAtual,
                IDOPCAO: tipoAlterac
                
            };
        }
        widgetFormRecalc.isVisible = false;
        widgetRecalc.isVisible = true;
        widgetRecalc.actions[0].isVisible = false;
        widgetRecalc.actions[1].isVisible = false;
        widgetRecalc.actions[2].isVisible = true;
        widgetRecalc.actions[3].isVisible = true;

        
        Ped05300_recalculo_preco_pedido_Service.buscaPedRecalc(row).then(function(response){
            setTimeout(function(){ 
                widgetRecalc.dataSource.data = response.dataset.dataSetRecalc.cdsPedido;
                widgetItensAtual.dataSource.data = response.dataset.dataSetRecalc.cdsItemPedAtual;
                widgetItensNovo.dataSource.data = response.dataset.dataSetRecalc.cdsItemPedNovo;
                widgetRecalc.reload();
            }, 30);
        });

    };

    
    this.recalcVrPedido = function(){ // recalcula o o valor dos pedidos
        var widgetFormRecalc = templateManager.container.getWidget('widgetRecalPrecoPed');
        var widgetPedRecal = templateManager.container.getWidget('widgetPedRecalc');
        var widgetAtiva = templateManager.container.getActiveWidget();
        var tipoAlterac =widgetFormRecalc.currentRow.IDOPCAO;
        var idAtual = widgetFormRecalc.currentRow.BODTATUAL;
        var row = [];
        
        
        if(widgetAtiva.name =="widgetRecalculo"){// valores da row quando recalculo é chamado na widget preço atual /alterado
             row.push({
                CDFILIAL:       widgetPedRecal.currentRow.CDFILIAL,
                NRPEDIDOINI:    widgetPedRecal.currentRow.NRPEDIDO,
                NRPEDIDOFIM:    widgetPedRecal.currentRow.NRPEDIDO,
                CDPRECOBASEINI: widgetPedRecal.currentRow.CDPRECOBASEINI,
                CDPRECOBASEFIN: widgetPedRecal.currentRow.CDPRECOBASEFIN,
                BODTATUAL:idAtual,
                IDOPCAO:tipoAlterac
    
            }); 
        }else if(widgetAtiva.name =="widgetPedRecalc" && widgetFormRecalc.isVisible == true){// valores da row quando recalculo é chamado na widget formulário
            row.push({
                CDFILIAL : widgetFormRecalc.currentRow.CDFILIAL,
                NRPEDIDOINI:widgetFormRecalc.currentRow.NRPEDIDOINI,
                NRPEDIDOFIM: widgetFormRecalc.currentRow.NRPEDIDOFIM,
                CDPRECOBASEINI:widgetFormRecalc.currentRow.CDPRECOBASEINI,
                CDPRECOBASEFIN: widgetFormRecalc.currentRow.CDPRECOBASEFIN,
                BODTATUAL:idAtual,
                IDOPCAO:tipoAlterac
                
    
       });
        }else{//verifica os valores marcados no grid e faz um foreach para row
            var checkeds = widgetPedRecal.getCheckedRows();
            var data = widgetPedRecal.dataSource.data;
            
            if(checkeds.length >= 1 && data.length !=  checkeds.length){
                checkeds.forEach(function(check){
                    row.push({
                        CDFILIAL : check.CDFILIAL,
                        NRPEDIDOINI:check.NRPEDIDO,
                        NRPEDIDOFIM: check.NRPEDIDO,
                        CDPRECOBASEINI:check.CDPRECOBASEINI,
                        CDPRECOBASEFIN: check.CDPRECOBASEFIN,
                        BODTATUAL:idAtual,
                        IDOPCAO:tipoAlterac
                    });
                });
            }else if(data.length ==  checkeds.length){
    
                row.push({
                    CDFILIAL : checkeds[0].CDFILIAL,
                    NRPEDIDOINI:checkeds[0].NRPEDIDO,
                    NRPEDIDOFIM: checkeds[checkeds.length-1].NRPEDIDO,
                    CDPRECOBASEINI:checkeds[0].CDPRECOBASEINI,
                    CDPRECOBASEFIN: checkeds[0].CDPRECOBASEFIN,
                    BODTATUAL:idAtual,
                    IDOPCAO:tipoAlterac
    
                });
            }
            
        }
    
        Ped05300_recalculo_preco_pedido_Service.recalcVrPedido(row).then(function(response){
                
            var result = response.dataset.codigo;
            var codigo = [];
            
            Object.keys(result).forEach(function(cod){
                codigo.push(cod);
            });
            
            if(codigo == "0"){
                
                ScreenService.showMessage('Recálculo realizado com sucesso.');
                
            }else if(codigo == "1"){
                
                ScreenService.showMessage('Produto sem preço. O preço de alguns itens não foi alterado.');
                
            }
            else if(codigo == "2"){
                
                ScreenService.showMessage('Produto sem preço. O preço base de alguns pedidos não foi alterado.');
                
            }else if(codigo == "3"){
                
                ScreenService.showMessage('Pedido com itens aprovados. O preço base de alguns pedidos não foi alterado.');
            }
            
            if(widgetAtiva.name == "widgetRecalculo"){
                
                ScreenService.goBack();
                this.buscaPedRecalc();
                
            }else if(widgetAtiva.name == "widgetPedRecalc" && widgetFormRecalc.isVisible == false){
                
                this.buscaPedRecalc();
                
            }else{
                
                widgetFormRecalc.getField('IDOPCAO').setValue('0');
                this.enableTabPreco();
            }
    
        }.bind(this));
    
    };
    
    
    
    this.cancelaRecalc = function(widget){
        var widgetFormRecalc = templateManager.container.getWidget('widgetRecalPrecoPed');
        var widgetRecalc = templateManager.container.getWidget('widgetPedRecalc');
        widgetFormRecalc.isVisible = true;
        widgetRecalc.isVisible = false;
        widgetRecalc.actions[0].isVisible = true;
        widgetRecalc.actions[1].isVisible = false;
        widgetRecalc.actions[2].isVisible = false;
        widgetRecalc.actions[3].isVisible = false;

    };
    
    this.setDataSourceFilterGrid = function(){//seta o dataSourceFilter da tela de item 
        var widgetPedGrid= templateManager.container.getWidget('widgetPedRecalc');
        var widgetItens= templateManager.container.getWidget('widgetRecalculo');
        var widgetItensAtual = templateManager.container.getWidget('widgetItemPrecoAtual');
        var widgetItensNovos = templateManager.container.getWidget('widgetItemPrecoAlterado');
        widgetItens.isVisible = true;
        widgetItens.activate();
        
        
        widgetItensAtual.dataSourceFilter = [];
        widgetItensNovos.dataSourceFilter= [];
        widgetItensAtual.dataSourceFilter = [{"name": "NRPEDIDO", "operator": "=","value": widgetPedGrid.currentRow.NRPEDIDO}];
        widgetItensAtual.reload();
        widgetItensNovos.dataSourceFilter = [{"name": "NRPEDIDO", "operator": "=","value": widgetPedGrid.currentRow.NRPEDIDO}];
        widgetItensNovos.reload();
        
        widgetItens.reload();
        
    };
    
};
Configuration(function(ContextRegister){
    ContextRegister.register('Ped05300_recalculo_preco_pedido_Controller', Ped05300_recalculo_preco_pedido_Controller);
});